#include "util.h"

FIBITMAP* GenericLoader(const char* pathName, int flag) {
	FREE_IMAGE_FORMAT fif = FIF_UNKNOWN;
	fif = FreeImage_GetFileType(pathName, 0);
	if (fif == FIF_UNKNOWN) {
		fif = FreeImage_GetFIFFromFilename(pathName);
	}
	if ((fif != FIF_UNKNOWN) && FreeImage_FIFSupportsReading(fif)) {
		FIBITMAP *dib = FreeImage_Load(fif, pathName, flag);
		return dib;
	}
	return NULL;
}

int readFeatureVectorsFromFile(char* filename, vector<FeatureVector>& featuresImg1, vector<FeatureVector>& featuresImg2) {
	string line;
	ifstream ifile;
	ifile.open(filename, ios::in);
	
	double asx, asy, aex, aey, bsx, bsy, bex, bey;
	int numFeatures = 0;
	
	if (ifile.is_open() && ifile.good()) {
		getline(ifile, line);
		istringstream isstream(line);
		isstream >> numFeatures;
		for (int i = 0; i < numFeatures; i++) {
			getline(ifile, line);
			istringstream isstream(line);
			isstream >> asx >> asy >> aex >> aey >> bsx >> bsy >> bex >> bey;
			FeatureVector feature1;
			FeatureVector feature2;
			feature1.P = vec2(asx, asy);
			feature1.Q = vec2(aex, aey);
			feature2.P = vec2(bsx, bsy);
			feature2.Q = vec2(bex, bey);
			featuresImg1.push_back(feature1);
			featuresImg2.push_back(feature2);
		}
	} else {
		return -1;
	}
	ifile.close();
	return numFeatures;

}

void flipFeatureVectors(vector<FeatureVector>& features,int width, int height) {
	for (unsigned int i = 0; i < features.size(); i++) {
		features[i].P[1] = height - features[i].P[1];
		features[i].Q[1]   = height - features[i].Q[1];
	}
}
